
precision mediump float;

varying vec4 v_v4Color;
varying vec2 v_v2TexCoord;
varying vec2 v_v2TexCoord2;
varying highp vec3 v_v3WorldPos;


uniform lowp sampler2D tex;

uniform vec3 u_v3AmbientColorNear;
uniform vec3 u_v3AmbientColorFarMinusNear;
uniform vec3 u_v3EyePos;
uniform vec3 u_v3WhiteWaterColor;

uniform highp float u_fTime;


vec2 LookUp(float fFrac2, highp float fTruncated, highp float fTime)
{
	float fMode = mod((fTruncated) * 34567.1, 27.0) * 0.02 + 0.4;
	float fMode_ = mod((fTruncated) * 2123.253, 13.0) * 0.01 + 0.5;

	
	float fTrueDepth = v_v2TexCoord.x;
	float fZoffset = fTrueDepth * -0.5;

	const float fOffsettt = -3.141 * 0.5;
	const vec4 v4AmbientOcclusion = vec4(0.1, 0.1, 0.1, 0.0);
	//vec2 v2Offset = -0.1 *  (fFrac2) * (u_v3EyePos - v_v3WorldPos).xy / length(u_v3EyePos - v_v3WorldPos);// * (fHardAlpha * fSoftAlpha);
	vec2 v2Offset = vec2(0);
	//gl_FragColor += fFraction * (0.0 + 0.5 * (fFrac2) +  texture2D(tex, v2Offset + 0.125 * vec2(v_v3WorldPos.x * fMode, v_v3WorldPos.y - fMode * (sin(fTime * fMode)))) - gl_FragColor);
	
	
	float fA = (texture2D(tex, v2Offset + fMode_ * 0.17 * vec2(-v_v3WorldPos.z * 0.023 + v_v3WorldPos.x * fMode + fMode * 0.33, fZoffset + fMode * v_v3WorldPos.y - fMode * (sin(fTime * fMode))))).r * (cos(fTime * fMode + fOffsettt) * 0.5 + 0.5);
	float fB = (texture2D(tex, v2Offset + fMode_ * 0.13 * vec2( v_v3WorldPos.z * 0.021 + v_v3WorldPos.x * fMode + .3 + fMode * 0.31, .4 + fZoffset + fMode * v_v3WorldPos.y - fMode * (sin(fTime * fMode + 3.141))))).r * (cos(fTime * fMode + 3.141 + fOffsettt) * 0.5 + 0.5);
    vec2 v2T = vec2(fA  + fB);
    v2T.y += 0.15 * fFrac2;

	/*
	float fHack = mod(fMode * 2786789.0, 3.0);
	if (fHack < 0.0)
		v4T = vec4(0.0, 0.0, 0.0, 1.0);
	else
	if (fHack < 0.9)
	{
		//v4T.x = 0.0;
	}
	else
	if (fHack < 1.9)
		v4T.y = 0.0;
	else
	if (fHack < 2.9)
		v4T.z = 0.0;*/

		
	//float fModeBlend = mod((fTruncated) * 2123.253, 13.0) * (1.0 / 13.0);
	//v4T.a *= fModeBlend * 0.5 + 0.5;

	
	float noiseGen2 = fract(sin(dot(v_v3WorldPos.xy, vec2(12.9898, 78.233))) * 43758.5453);
	float offset = noiseGen2;
	offset -= 0.5;
	v2T.x += offset*0.3;	
	
	noiseGen2 = fract(sin(dot(v_v3WorldPos.xy, vec2(15.9898, 47.233))) * 33758.5453);
	offset = noiseGen2;
	offset -= 0.5;
	v2T.y += offset*0.3;

	return v2T;
}



#ifdef NEW_FOAM
void main()
{
	float fSoftAlpha = v_v4Color.a;
	float fHardAlpha = v_v4Color.r;
	float fDepth = v_v4Color.g;
	float fBrightness = v_v4Color.b;

	float fTrueDepth = v_v2TexCoord.x;
	float fScale = v_v2TexCoord.y;

   


	float fDist = v_v3WorldPos.x * 0.2 - v_v3WorldPos.z * 0.02 + sqrt(max(0.0, v_v3WorldPos.y + 0.5))* 8.5 + 1.6 * sin(v_v3WorldPos.x * 0.4 - v_v3WorldPos.z * 0.3 ) +  1.5 * sin(v_v3WorldPos.x * 0.25 - v_v3WorldPos.z * 0.17 ) +  1.7 * sin(-v_v3WorldPos.x * 0.77 - v_v3WorldPos.z * 0.51 );
	//fDist *= 0.5 / fTrueDepth;
	float fDist2 = fDist / (fScale + 0.2);

//	float fFraction = mod(fDist2, 1.0);
//	float fTruncated = fDist2 - fFraction;
	float fTruncated = floor(fDist2);
	float fFraction = fDist2 - fTruncated;

	/*bool bTest = false;
	if (fFraction >= 1.0)
	{
		fFraction -= 1.0;
		fTruncated -= 1.0;
		bTest = true;
	}

	if (fFraction < 0.0)
	{
		fFraction += 1.0;
		fTruncated += 1.0;
		bTest = true;
	}*/



	//float fScaleTrunc = fDist / fTruncated - 0.2;

	//int nTest = ((int(fTruncated) + 1) * 345);
	//float fMode = float(nTest - nTest / 27 * nTest) * 0.02 + 0.4;
	//int nTest2 = nTest - 345;
	//float fMode2 = float(nTest2 - nTest2 / 27 * nTest2) * 0.02 + 0.4;


	
	float fMode_ = 0.5;
	//float fMode_ = 1.0 / fScaleTrunc;

	

	float fFrac2 = fFraction;

	//float fTime = v_v3WorldPos.z * 0.3;//u_fTime * 0.8;
	float fTime = u_fTime;


	vec2 v2IntensityAlpha = LookUp(fFrac2, fTruncated, fTime);

	
	
	fFraction *= 6.0;
	fFraction -= (v2IntensityAlpha.x) * 5.0;
	fFraction *= max(fFrac2 * 4.0, 1.0);

	if (fFraction < 0.0)
		fFraction = 0.0;
	else
	if (fFraction > 1.0)
		fFraction = 1.0;



	vec2 v2T = LookUp(fFrac2 - 1.0, fTruncated + 1.0, fTime);

	v2IntensityAlpha += fFraction * (v2T - v2IntensityAlpha);

	v2IntensityAlpha = min(v2IntensityAlpha, vec2(1.0));
	v2IntensityAlpha = max(v2IntensityAlpha, vec2(0.0));

	
    gl_FragColor.a = v2IntensityAlpha.y;
//	gl_FragColor.a = (gl_FragColor.a) * (0.5 + fHardAlpha * 0.1) - 1.0 + fHardAlpha * 2.0;
	gl_FragColor.a = -(1.0 - gl_FragColor.a) * 4.0  + fHardAlpha * 5.0;

	gl_FragColor.a *= max(fHardAlpha * 2.0, 1.0);
	
	float fShadow = gl_FragColor.a;
	fShadow += fBrightness;
	if (fShadow < 0.0)
		fShadow = 0.0;
	else
	if (fShadow > 1.0)
		fShadow = 1.0;
	gl_FragColor.a *= fSoftAlpha;
	if (gl_FragColor.a < 0.0)
		gl_FragColor.a = 0.0;
	if (gl_FragColor.a > 1.0)
		gl_FragColor.a = 1.0;

		
	if (fBrightness < 0.0)
	{
		gl_FragColor.a -= fBrightness * fBrightness;
		fBrightness *= 0.25;
	}



	if (fBrightness + v2IntensityAlpha.x * 1.0 < 0.75)
	{
		fBrightness -= 0.05;
		gl_FragColor.a *= gl_FragColor.a;
		gl_FragColor.a *= 0.6;

		
		//gl_FragColor.a += fBrightness * 1.0;

		//fBrightness -= (1.0 - v2IntensityAlpha.x) * 4.0  - fBrightness * 5.0;

	}

		 
	v2IntensityAlpha.x = 0.7 + v2IntensityAlpha.x * 0.5;		
	//v2IntensityAlpha.x += 0.125;
	//v2IntensityAlpha.x = pow(v2IntensityAlpha.x, 2.25);



	
	fDepth *= 0.1;
	if (fDepth > 1.0)
		fDepth = 1.0;
	vec3 v3ColorA  = u_v3AmbientColorNear + u_v3AmbientColorFarMinusNear * fDepth;
	vec3 v3ColorB = vec3(1.0, 1.0, 1.0);

	
	//if (fBrightness < 0.0)
	//	fBrightness *= 0.1;//gl_FragColor.r * 0.5;
	//if (fBrightness < 0.0)
	//	gl_FragColor.x += fBrightness * 0.2;
	fBrightness *= 0.7 + (v2IntensityAlpha.x) * 0.4;
	if (fBrightness > 1.0)
		fBrightness = 1.0;

	fBrightness = 1.0 + ((v2IntensityAlpha.x) *0.5 - 1.0) * (1.0 - fBrightness);

	if (fBrightness > 1.0)
		fBrightness = 1.0;



	gl_FragColor.xyz = (v3ColorB - v3ColorA) * fBrightness + v3ColorA;
	
	gl_FragColor.xyz *= u_v3WhiteWaterColor;



	
}

#else

varying vec2 v_v2TexCoordTransformed;
varying vec2 v_v2TexCoordTransformed2;
varying vec2 v_v2ParallaxOffset;

void main()
{
	float fSoftAlpha = v_v4Color.a;
	float fHardAlpha = v_v4Color.r;
	float fDepth = v_v4Color.g;
	float fBrightness = v_v4Color.b;

  //  gl_FragColor = vec4(v_v4Color);
   // return;


	float fColor_ = texture2D(tex, v_v2TexCoordTransformed).r;
	float fColor2_ = texture2D(tex, v_v2TexCoordTransformed2).r;

	
	//vec4 a_color = color_ - 0.5;
	//vec4 a_color2 = color2_ - 0.5;
	//float fR = -v_v3WorldPos . z * 0.25;
	//fR += -v_v3WorldPos .y * 1.0;
	//fR += -v_v3WorldPos .x * 0.25;
   // color_ =  0.5 + a_color * sin(fR) + a_color2 * cos(fR);
   // color2_ = 0.5 + -a_color * cos(fR) + a_color2 * sin(fR);


	float fIntensity = fColor_ + fColor2_;
	vec2 v2Offset = vec2(-fIntensity * 0.1, -fIntensity * 0.1);


	//v2Offset = vec2(0.0, 0.0);
	float fAAA = fIntensity * 0.5;
	//v2Offset = v2Offset * 0.5 + 0.25 * (u_v3EyePos - v_v3WorldPos).xy / length(u_v3EyePos - v_v3WorldPos) * ( fAAA * fHardAlpha * fSoftAlpha);
	v2Offset = v2Offset * 0.5 + v_v2ParallaxOffset * fAAA;



	float fColor = texture2D(tex, v2Offset + vec2(v_v2TexCoord.s, 0.9 * (v_v2TexCoord2.t * 0.151) + v_v2TexCoord2.s * 0.23)).r;
	float fColor2 = texture2D(tex, v2Offset + vec2(-v_v2TexCoord.s * 0.8, 0.7 * (v_v2TexCoord2.t * 0.09) - v_v2TexCoord2.s * 0.27)).r;

	
	float fR = v_v3WorldPos.z * -1.0*(fColor2 + 1.0);
	fR += v_v3WorldPos .y * 2.0 * (fColor + 1.0);
	fR += -v_v3WorldPos .x * 0.02;

	float fColorz = fColor * (sin(fR) * 0.5 + 0.5);

	float fColor2z = fColor2 * (cos(fR) * 0.5 + 0.5);
	


	if (fColorz * 2.0 > fColor2)
		fColor2 = fColor * 0.5 + fColor2 * 0.5;
	else
		fColor = fColor * 0.5 + fColor2 * 0.5;
		


	gl_FragColor.a = (fColor + fColor2) * (0.5 + fHardAlpha * 0.1) - 1.0 + fHardAlpha * 2.0;
	
	gl_FragColor.a -= 0.5;
	gl_FragColor.a *= 2.0;
	gl_FragColor.a += 0.5;

	float fShadow = gl_FragColor.a;
	fShadow += fBrightness;
	if (fShadow < 0.0)
		fShadow = 0.0;
	else
	if (fShadow > 1.0)
		fShadow = 1.0;



	
	fDepth *= 0.1;
	if (fDepth > 1.0)
		fDepth = 1.0;
	vec3 v3ColorA  = u_v3AmbientColorNear + u_v3AmbientColorFarMinusNear * fDepth;
	vec3 v3ColorB = vec3(1.0, 1.0, 1.0);

	
	if (fBrightness < 0.0)
		fBrightness = 0.0;
	fBrightness *= 0.7 + (fColor + fColor2) * 0.4;
	if (fBrightness > 1.0)
		fBrightness = 1.0;
	fBrightness = 1.0 + ((fColor * fColor2) * 0.5 - 1.0) * (1.0 - fBrightness);

	if (fBrightness > 1.0)
		fBrightness = 1.0;

		//gl_FragColor.a -= fBrightness;


	gl_FragColor.xyz = (v3ColorB - v3ColorA) * fBrightness + v3ColorA;



	gl_FragColor.a *= fSoftAlpha;
	if (gl_FragColor.a < 0.0)
		gl_FragColor.a = 0.0;
	if (gl_FragColor.a > 1.0)
		gl_FragColor.a = 1.0;
		gl_FragColor.a *= (fShadow * 0.5 + 0.5);
			


	gl_FragColor.xyz *= u_v3WhiteWaterColor;

	
}

#endif
