

uniform mat4 u_m44ModelViewProjection;
uniform float u_fDepthOffset;

attribute vec4 a_v4Position;
attribute vec2 a_v2TexCoord;
attribute vec2 a_v2TexCoord2;
attribute vec4 a_v4Color;

varying mediump vec4 v_v4Color;
varying highp vec3 v_v3WorldPos;
varying mediump vec2 v_v2TexCoord;
varying mediump vec2 v_v2TexCoord2;

const mat4 m44Offset = mat4( 
	0.5, 0.0, 0.0, 0.0,
	0.0, 0.5, 0.0, 0.0, 
	0.0, 0.0, 0.0, 0.0,
	0.5, 0.5, 0.0, 1.0);
	
#ifndef NEW_FOAM
varying mediump vec2 v_v2TexCoordTransformed;
varying mediump vec2 v_v2TexCoordTransformed2;
varying mediump vec2 v_v2ParallaxOffset;


uniform highp vec3 u_v3EyePos;
#endif

void main() 
{
	//v_v2TexCoord.x = gl_Vertex.x * 0.5 + 0.5;
	//v_v2TexCoord.y = gl_Vertex.y * 0.5 + 0.5;
		
	v_v2TexCoord=a_v2TexCoord; 
	v_v2TexCoord2=a_v2TexCoord2; 
	gl_Position = u_m44ModelViewProjection * a_v4Position;
	v_v4Color = a_v4Color;
	v_v3WorldPos = a_v4Position.xyz;
	
	float fDiv = gl_Position.w;
	if (fDiv < 0.001)
		fDiv = 0.001;
		
#ifdef NEW_FOAM
	float zOffset = 2.0 * a_v2TexCoord.y / fDiv;
#else
	float zOffset = u_fDepthOffset / fDiv;

	v_v2TexCoordTransformed = vec2(v_v2TexCoord.s, 0.9 * (v_v2TexCoord2.t * 0.43) + v_v2TexCoord2.s * 0.23);
	v_v2TexCoordTransformed2 =  vec2(-v_v2TexCoord.s * 0.8, 0.7 * (v_v2TexCoord2.t * 0.71) - v_v2TexCoord2.s * 0.127);
	float fSoftAlpha = v_v4Color.a;
	float fHardAlpha = v_v4Color.r;
	v_v2ParallaxOffset = 0.25 * (u_v3EyePos - v_v3WorldPos).xy / length(u_v3EyePos - v_v3WorldPos) * (fHardAlpha * fSoftAlpha);
#endif

	if (zOffset < 0.001)
		zOffset = 0.001;
	gl_Position.z -= zOffset;
}
