uniform mat4 u_m44ModelViewProjection;
//uniform float u_fDepthOffset;

attribute vec4 a_v4Position;
attribute vec2 a_v2TexCoord;
attribute vec4 a_v4Color;

varying lowp float v_fAlpha;
varying highp vec3 v_v3WorldPos;
varying mediump vec2 v_v2TexCoord;
varying mediump vec2 v_v2TexCoord2;
uniform highp vec3 u_v3EyePos;


void main() 
{		
	const float fPi = 3.1415926535897932384626433832795;
	const float fRoot2 = 1.4142135623730950488016887242097;

	v_v2TexCoord.x = cos(a_v2TexCoord.x + fPi * 0.0) * (0.5 * fRoot2) + 0.5; 
	v_v2TexCoord.y = sin(a_v2TexCoord.x + fPi * 0.0) * (0.5 * fRoot2) + 0.5; 
	v_v2TexCoord2.x = v_v2TexCoord.x + a_v2TexCoord.y;
	v_v2TexCoord2.y = v_v2TexCoord.y + a_v2TexCoord.y * 4.0;

	float fTime = a_v4Color.r;
	float fTimeStart = a_v4Color.a;
	
	float fSize = 1.0 - exp((fTimeStart - fTime) * 1.0);
	fSize *= 2.5;
	float fRotationAnimation = fTime * sin(a_v2TexCoord.y * 11.11) * 2.0 + sin(a_v2TexCoord.y * 12.11);
	vec3 v3Diag = vec3(cos(a_v2TexCoord.x + fRotationAnimation), sin(a_v2TexCoord.x + fRotationAnimation), 0.0) * fSize;
	

	mat3 m33FaceMe;
	m33FaceMe[2] = normalize(u_v3EyePos - a_v4Position.xyz);
	m33FaceMe[0] = normalize(cross(m33FaceMe[2], vec3(0.0, 1.0, 0.0))); // Note, not going to work if camera is facing straight up or down
	m33FaceMe[1] = cross(m33FaceMe[2], m33FaceMe[0]);

	gl_Position = u_m44ModelViewProjection * (a_v4Position + vec4(m33FaceMe * v3Diag, 0.0));
	//gl_Position = u_m44ModelViewProjection * (a_v4Position + vec4(v3Diag, 0.0));
	
	v_v3WorldPos = a_v4Position.xyz;
	//v_v4Color = a_v4Color;

	v_fAlpha = 1.0 - (fTimeStart - fTime) / fTimeStart;

	/*v_fAlpha *= 2.0;
	if (v_fAlpha > 1.0)
	v_fAlpha = 1.0;*/
	
	/*float fDiv = gl_Position.w;
	if (fDiv < 0.001)
		fDiv = 0.001;
	float zOffset = u_fDepthOffset / fDiv;
	if (zOffset < 0.001)
		zOffset = 0.001;
	gl_Position.z -= zOffset;*/
}
