

precision mediump float;

varying lowp vec4 v_v4Color;
varying lowp vec3 v_v3MatrixX;
varying lowp vec3 v_v3MatrixY;
varying lowp vec3 v_v3MatrixZ;
varying highp vec2 v_v2TexCoordSmallDetail;
varying highp vec2 v_v2TexCoordBigDetail;
varying highp vec4 v_v4TexCoordReflection;
varying highp vec2 v_v2TexCoordWake;
varying highp vec2 v_v2TexCoordCostics;
varying highp vec3 v_v3WorldPos;

uniform float u_fReflection;
uniform vec3 u_v3TransmitionColorNear;
uniform vec3 u_v3TransmitionColorFarMinusNear;

uniform mat3 m33NormalRotation;
uniform lowp sampler2D texSmallDetail;
uniform lowp sampler2D texWake;
uniform lowp sampler2D texReflection;
uniform lowp sampler2D texFoam;

uniform vec3 u_v3EyePos;
uniform float u_fProjectionOffset;
uniform vec3 u_v3WhiteWaterColor;
uniform float u_fOneMinusSmallDetailAmplitude;

uniform vec3 u_v3LightDir;
uniform vec3 u_v3LightDiffuse;
uniform vec3 u_v3LightSpecularSoft;
uniform vec3 u_v3LightSpecular;
uniform vec3 u_v3LightTransmition;

uniform float u_fAngle1;
/*mat2 c_m22TextureRotation1 = mat2(
	cos(-u_fAngle1), sin(-u_fAngle1),
	-sin(-u_fAngle1), cos(-u_fAngle1));
mat2 c_m22TextureRotation1b = mat2( 
	cos(u_fAngle1), sin(u_fAngle1),
	-sin(u_fAngle1), cos(u_fAngle1));*/

uniform mat2 c_m22TextureRotation1;
uniform mat2 c_m22TextureRotation1b;


#ifdef MULTI_LAYER_WATER_TEXTURE
uniform sampler2D texBigDetail;
uniform float u_fOneMinusBigDetailAmplitude;
uniform float u_fAngle2;
//mat2 c_m22TextureRotation2 = mat2(
//	cos(-u_fAngle2), sin(-u_fAngle2),
//	-sin(-u_fAngle2), cos(-u_fAngle2));
uniform mat2 c_m22TextureRotation2;
#endif

#define COSTICTS


void main()
{
 //   gl_FragColor = vec4(v_v3MatrixY, 1.0);
 //   return;
	
#ifdef MULTI_LAYER_WATER_TEXTURE
	vec4 v4NormalMap2 = texture2D(texBigDetail, v_v2TexCoordBigDetail.st);
	v4NormalMap2 += u_fOneMinusBigDetailAmplitude * (vec4(0.5, 0.5, 0.5, 0.5) - v4NormalMap2);
	v4NormalMap2 -= vec4(0.5);
	v4NormalMap2 *= 2.0;
	v4NormalMap2.xy *= c_m22TextureRotation2;
	v4NormalMap2.zw *= c_m22TextureRotation2;
	vec3 v3NormalMap2 = vec3(-v4NormalMap2.x, sqrt(1.0 - dot(v4NormalMap2.xy, v4NormalMap2.xy)), -v4NormalMap2.y);

	vec4 v4NormalMap = texture2D(texSmallDetail, v_v2TexCoordSmallDetail.st + v4NormalMap2.zw * 0.5);
	v4NormalMap += u_fOneMinusSmallDetailAmplitude * (vec4(0.5, 0.5, 0.5, 0.5) - v4NormalMap);
	//highp vec4 v4NormalMap = texture2D(texSmallDetail, v_v2TexCoordSmallDetail.st);
	v4NormalMap -= vec4(0.5);
	v4NormalMap *= 2.0;
	v4NormalMap.xy *= c_m22TextureRotation1;
	v4NormalMap.zw *= c_m22TextureRotation1;
	vec3 v3NormalMap = vec3(-v4NormalMap.x, sqrt(1.0 - dot(v4NormalMap.xy, v4NormalMap.xy)), -v4NormalMap.y);
	//v3NormalMap2.y *= 0.5; v3NormalMap2 = normalize(v3NormalMap2);	

	// rotate normal method A
	//mat3 m33Rotation = mat3(
	//	v3NormalMap2.y, -v3NormalMap2.x, v3NormalMap2.z,
	//	v3NormalMap2.x, v3NormalMap2.y, v3NormalMap2.z,
	//	v3NormalMap2.x, v3NormalMap2.z, -v3NormalMap2.y);	
	//v3NormalMap = m33Rotation * v3NormalMap;	
	
	// rotate normal method B
	vec3 t = vec3(v3NormalMap2.x, v3NormalMap2.y + 1.0, v3NormalMap2.z);
	vec3 u = vec3(-v3NormalMap.x, v3NormalMap.y, -v3NormalMap.z);
	v3NormalMap = t*dot(t, u)/t.y - u;
	//v3NormalMap = normalize(t*dot(t, u) - u*t.y);

	// un optimized	
	//vec3 t = (v3NormalMap2 * 0.5 + 0.5)*vec3( 2, 2,  2) + vec3(-1,  0, -1);
	//vec3 u = (v3NormalMap *  0.5 + 0.5)*vec3(-2, 2, -2) + vec3( 1, -1,  1);
	//v3NormalMap = t*dot(t, u)/t.y - u;
	//v3NormalMap = normalize(t*dot(t, u) - u*t.y);
	
	// z up rather then y up
	//vec3 t = (v3NormalMap2.xzy * 0.5 + 0.5)*vec3( 2,  2, 2) + vec3(-1, -1,  0);
	//vec3 u = (v3NormalMap.xzy * 0.5 + 0.5)*vec3(-2, -2, 2) + vec3( 1,  1, -1);
	//vec3 n = t*dot(t, u)/t.z - u;
	//vec3 n = normalize(t*dot(t, u) - u*t.z);	
	//v3NormalMap = n.xzy;

	v4NormalMap.zw += v4NormalMap2.zw * 5.0;

#else
	vec4 v4NormalMap = texture2D(texSmallDetail, v_v2TexCoordSmallDetail.st);
	v4NormalMap += u_fOneMinusSmallDetailAmplitude * (vec4(0.5, 0.5, 0.5, 0.5) - v4NormalMap);
	v4NormalMap -= 0.5;
    v4NormalMap *= 2.0;
    v4NormalMap.xy *= c_m22TextureRotation1;
    v4NormalMap.zw *= c_m22TextureRotation1;
	vec3 v3NormalMap = vec3(v4NormalMap.x, sqrt(1.0 - dot(v4NormalMap.xy, v4NormalMap.xy)), v4NormalMap.y);
	
#endif


	vec3 v3NormalMapFoam = texture2D(texFoam,v_v2TexCoordSmallDetail.st * 0.7 + v4NormalMap.zw * 0.1).xyy;
	v3NormalMapFoam -= 0.5;
	v3NormalMapFoam *= 100.0;


	vec3 texWake = texture2D(texWake, v_v2TexCoordWake).xyz;
	
	v3NormalMap.y += texWake.x * 4.0;
	v3NormalMapFoam += (v3NormalMap - v3NormalMapFoam) * 0.2;


	

	vec3 v3Normal;
	v3Normal.x = dot(v3NormalMap, v_v3MatrixX);
	v3Normal.y = dot(v3NormalMap, v_v3MatrixY);
	v3Normal.z = dot(v3NormalMap, v_v3MatrixZ);
	v3Normal = normalize(v3Normal);


	highp vec3 v3Incident = v_v3WorldPos - u_v3EyePos;
	float fIncidentLength = length(v3Incident);
	vec3 v3Reflection = reflect(v3Incident, v3Normal) / fIncidentLength;
	float fSpec = dot(v3Reflection, u_v3LightDir);
	float fSpecSoft = (dot(v3Reflection, u_v3LightDir) + 2.0) * (1.0 / 3.0);


	
	//if (fSpec < 0.0)
	//	fSpec = 0.0;
   // fSpec = pow(fSpec, 400.0); 

    const float fSpecHack = 0.005;
    fSpec -= 1.0 - fSpecHack;
	fSpec *= 1.0 / fSpecHack;
	fSpec = clamp(fSpec, 0.0, 1.0);
	fSpec *= fSpec;
    

	float fDiffuseIntensity = (dot(v3Normal, u_v3LightDir) + 3.0) * (1.0 / 4.0);

	//vec3 v3Bck;
//	gl_FragColor.xyz = vec3(0.0, 0.1, 0.2) * fDiffuseIntensity + fSpec2 * vec3(0.0, 0.08, 0.16);
	gl_FragColor.xyz = u_v3LightDiffuse * fDiffuseIntensity + u_v3LightSpecular * fSpec + u_v3LightSpecularSoft * fSpecSoft;
   // gl_FragColor.xyz = vec3(0.0);


	float fWhite = v_v4Color.r;
	fWhite *= 2.0;
	fWhite -= texWake.x * texWake.x * texWake.x * 100.0;

	//v4Color.x -= (v_v3WorldPos.x + 50.0) * 0.007;


	fWhite = 1.0 - abs(v3NormalMapFoam.y) * abs(v3NormalMapFoam.x) * 10.0 * fWhite * fWhite  - fWhite * fWhite * fWhite * 0.2 ;
	fWhite -= 0.5;
	fWhite *= 2.0;
	fWhite += 0.5;

	if (fWhite < 0.0)
		fWhite = 0.0;
	if (fWhite > 1.0)
		fWhite = 1.0;
		

		
	vec3 v3ReflectionDiff = normalize(reflect(v3Incident, v_v3MatrixY));
	v3ReflectionDiff -= v3Reflection;
	v3ReflectionDiff.y = -v3ReflectionDiff.y;
	v3ReflectionDiff = - v3ReflectionDiff;

	vec3 v3Side = normalize(cross(v3Incident, vec3(0.0, 1.0, 0.0)));

	v3ReflectionDiff.x = dot(v3Side, v3ReflectionDiff);
	v3ReflectionDiff.z = 0.0;
	v3ReflectionDiff.y *= -2.0;

	vec4 v4ReflectionMap = texture2DProj(texReflection, v_v4TexCoordReflection + vec4((v3ReflectionDiff.xy * 0.02 + v_v3MatrixY.zx * 0.01 * 0.4 - vec2(0.0, 0.005 * 0.4)) * u_fProjectionOffset * v_v4TexCoordReflection.w, 0.0, 0.0));

		
	gl_FragColor.xyz += v4ReflectionMap.xyz * u_fReflection;

	
	vec3 v3IncidentNormal = v3Incident / fIncidentLength;


	//float fTest = -dot(v3Normal, v3IncidentNormal);
	//float fTest = -dot(v_v3MatrixY + v3NormalMap * 0.1, v3IncidentNormal);
	float fTest = -dot(v3Normal, v3IncidentNormal);
	//float fTest = -dot(v3Normal, normalize(v3IncidentNormal - v3Normal));

	/*fTest -= 0.1;
	fTest *= 1.0 / 0.9;
	if (fTest < 0.0)
		fTest = 0.0;
	//fTest *= fTest;
	fTest = sqrt(fTest);*/
	
	if (fTest < 0.0)
		fTest = 0.0;
	float r = 0.3;
	fTest = r + (1.0 - r) * pow(1.0 - fTest, 5.0);
	fTest = 1.0 - fTest;
	

	//float fWorldPos = -v_v3WorldPos.z + 160.0;
	//if (fWorldPos < 0.0)
	//	fWorldPos = 0.0;

	float fDepth = v_v4Color.g;
	float fShadow = v_v4Color.b;

	//vec3 v3TransmitionColor = vec3(0.0, 0.2 + fDepth * 0.002, 0.5);

	float fTransimtionLerp = fDepth * 0.1;
	if (fTransimtionLerp > 1.0)
		fTransimtionLerp = 1.0;
	vec3 v3TransmitionColor = u_v3TransmitionColorNear + u_v3TransmitionColorFarMinusNear * fTransimtionLerp;
    float fTransmitionColorAdd = 0.0;

	float fDot = dot(v3IncidentNormal, (v3Normal));
	float r2 = 0.3;
	vec3 v3Refaction = r2 * v3IncidentNormal + ( fDot * v3IncidentNormal - sqrt(1.0 - r2 * r2 * (1.0 - fDot * fDot))) * v3Normal;

	float fOffset = 10.0 - v_v3MatrixY.y * 9.0;
	if (v3Refaction.y > -fOffset)
	{
		float fBrighten = (v3Refaction.y + fOffset) * 0.08;
		if (fBrighten > 0.1)
			fBrighten = 0.1;
		fTransmitionColorAdd += fBrighten;// * vec3(1.0, 0.7, 0.0);
	}

	float fLightRef = dot(normalize(v3Refaction), u_v3LightDir);
	if (fLightRef > 0.0)
	{
		//fLightRef = (pow(fLightRef, 32.0) + fLightRef * fLightRef) * 0.6;
		fLightRef *= fLightRef;
		v3TransmitionColor += fLightRef * u_v3LightTransmition;//   vec3(0.4, 0.3, 0.0);
	}

	if (v3Refaction.y > -0.8)
	{
		float fBrighten = (v3Refaction.y + 0.8) * 0.3;
		if (fBrighten > 0.15)
			fBrighten = 0.15;
		fTransmitionColorAdd += fBrighten;
	}

	float fReractionDepth = fDepth;
    
#ifdef COSTICTS
	if (v3Refaction.y < -0.8)
	{
		if (fReractionDepth < 20.0)
			fReractionDepth = 20.0;
		float fTransimtionDenomenator = ((0.05 + dot(v3Refaction.xz, v3Refaction.xz)) * (fReractionDepth * 0.2  + v_v3WorldPos.y * 0.15)) * (-v3Refaction.y + 0.8);
		if (fTransimtionDenomenator < 256.0)
		{
			vec3 v3Costics;
			v3Costics = texture2D(texSmallDetail, v_v2TexCoordCostics + v3Refaction.xz * c_m22TextureRotation1b * ((fDepth * 0.02 + v_v3WorldPos.y * 1.0))).xyy;
			v3Costics -= 0.5;
			v3Costics *= 2.0;
			float fCostics =  1.0 - dot(v3Costics.xy, v3Costics.xy) * 3.0;

			if (fCostics > 0.0)
			{
				fCostics = 1.0 - fCostics;
				fCostics *= 1.0 - u_fOneMinusSmallDetailAmplitude;

				fTransmitionColorAdd +=
					fCostics /
					fTransimtionDenomenator;
			}
		}
	}
#endif
    
    
    v3TransmitionColor += fTransmitionColorAdd;

	
	gl_FragColor.xyz *= fShadow;// * (vec3(1.0, 1.0, 1.0) - vec3(0.7, 0.8, 0.95)) + vec3(0.7, 0.8, 0.95);

	gl_FragColor.xyz += fTest * (v3TransmitionColor - gl_FragColor.xyz);

	//gl_FragColor.xyz += fTest * (vec3(fWorldPos * 0.003, 0.2 + fWorldPos * 0.001, 0.5 - fWorldPos * 0.003) - gl_FragColor.xyz);
	
		
	

	gl_FragColor.xyz += fWhite * (u_v3WhiteWaterColor - gl_FragColor.xyz) ;
	gl_FragColor.xyz += (1.0 - exp2(-0.000001 * fIncidentLength * fIncidentLength)) * (v4ReflectionMap.xyz - gl_FragColor.xyz);


	
	
	
	//highp vec4 v4NormalMap5 = texture2D(texSmallDetail,v_v2TexCoordSmallDetail.st);
	//v4NormalMap5 -= 0.5;
	//v4NormalMap5 *= 2.0;
	//gl_FragColor.xyz = v4NormalMap5.xyz;
	
	gl_FragColor.a = 1.0;
#ifdef REFLECTION
	// fade out reflections in back ground to hide blocky artifacts caused by low res reflection render
	gl_FragColor.a = 2.2 - fIncidentLength * 0.008; // todo move alpha calc to vertex shader
    if (gl_FragColor.a < 0.0)
        gl_FragColor.a = 0.0;

	// fudge to fade out edges of waves in reflections to smooth blocky artifacts. (Might be better to test vertical angle versus the vertical angle of the camera in a smarter way
	//float fAlphaEdges = dot(v3IncidentNormal, v_v3MatrixY) * -1.5;
	const float fHardness = 10.0;
	float fAlphaEdges =  fHardness - v_v3MatrixY.y * fHardness;
	if (fAlphaEdges > 1.0)
		fAlphaEdges = 1.0;
	else
	if (fAlphaEdges < 0.0)
		fAlphaEdges = 0.0;

	gl_FragColor.a *= fAlphaEdges;


#endif


   
#ifdef TRANSPARENT_JOINING_STRIP
	gl_FragColor.a = v_v4Color.a;
	//gl_FragColor.r = 1.0;
#else
	gl_FragColor.a = 0.0;
#endif

	//if (gl_FragColor.a > 1.0)
	//gl_FragColor.a = 1.0;
	//gl_FragColor.a *= 0.5;
    
  //  gl_FragColor = v4NormalMap * 5.0;
  //  gl_FragColor.a = 0.01;


}
