
uniform mat4 u_m44ModelViewProjection;
uniform vec2 u_v2BigDetailOffset;
uniform vec2 u_v2SmallDetailOffset;

attribute vec4 a_v4Position;
attribute vec2 a_v2TexCoord;
attribute vec2 a_v2TexCoord2;
attribute vec3 a_v3MatrixX;
attribute vec3 a_v3MatrixY;
attribute vec3 a_v3MatrixZ;	
attribute vec4 a_v4Color;

varying lowp vec4 v_v4Color;
varying lowp vec3 v_v3MatrixX;
varying lowp vec3 v_v3MatrixY;
varying lowp vec3 v_v3MatrixZ;
varying highp vec2 v_v2TexCoordSmallDetail;
varying highp vec2 v_v2TexCoordBigDetail;
varying highp vec4 v_v4TexCoordReflection;
varying highp vec2 v_v2TexCoordWake;
varying highp vec2 v_v2TexCoordCostics;
varying highp vec3 v_v3WorldPos;
//varying vec2 v2ReflectionUV;


const mat4 m44Offset = mat4( 
	0.5, 0.0, 0.0, 0.0,
	0.0, 0.5, 0.0, 0.0, 
	0.0, 0.0, 0.0, 0.0,
	0.5, 0.5, 0.0, 1.0);

const float c_fAngle = 0.0;
const mat2 c_m22TextureRotation = mat2( 
	cos(c_fAngle), sin(c_fAngle),
	-sin(c_fAngle), cos(c_fAngle));

uniform float u_fAngle1;

#ifdef MULTI_LAYER_WATER_TEXTURE
uniform float u_fAngle2;
#endif

void main() 
{
mat2 c_m22TextureRotation1 = mat2(
	cos(u_fAngle1), sin(u_fAngle1),
	-sin(u_fAngle1), cos(u_fAngle1));

#ifdef MULTI_LAYER_WATER_TEXTURE
mat2 c_m22TextureRotation2 = mat2(
	cos(u_fAngle2), sin(u_fAngle2),
	-sin(u_fAngle2), cos(u_fAngle2));
#endif

	v_v2TexCoordSmallDetail = a_v2TexCoord * 2.0 * c_m22TextureRotation1 + u_v2SmallDetailOffset;
#ifdef MULTI_LAYER_WATER_TEXTURE
	v_v2TexCoordBigDetail = a_v2TexCoord * 2.0 * c_m22TextureRotation2 * 0.194556 + u_v2BigDetailOffset;
#endif
	gl_Position = u_m44ModelViewProjection * a_v4Position;
	v_v4Color  = a_v4Color;
	v_v4Color.b = v_v4Color.b * 0.5 + 0.5; // brighten shadow
	v_v3MatrixX = normalize(a_v3MatrixX);
	v_v3MatrixY = normalize(a_v3MatrixY);
	v_v3MatrixZ = normalize(a_v3MatrixZ);
	v_v3WorldPos = a_v4Position.xyz;
	v_v4TexCoordReflection = m44Offset * (u_m44ModelViewProjection * (a_v4Position - vec4(0.0, v_v3WorldPos.y * 2.0, 0.0, 0.0))) ;
//	v_v4TexCoordReflection = m44Offset * u_m44ModelViewProjection * (a_v4Position - vec4(0.0, v_v3WorldPos.y * 0.0, 0.0, 0.0)) ;
	v_v2TexCoordWake = a_v2TexCoord2 * c_m22TextureRotation;
	v_v2TexCoordWake = 0.01 * vec2((v_v2TexCoordWake.s + 50.0), -(v_v2TexCoordWake.t - 50.0));
    v_v2TexCoordCostics = a_v4Position.xz * c_m22TextureRotation1 * 0.081 + u_v2SmallDetailOffset * 0.8;

	

}
