
precision mediump float;

uniform sampler2D tex;


varying highp vec2 v_arrv2TexCoord[ARRAY_SIZE];

uniform highp vec2 u_v2NormalArray[ARRAY_SIZE];
uniform highp float u_fScaleArray[ARRAY_SIZE];
uniform float u_fContributionArray[ARRAY_SIZE];
uniform float u_fChoppyness;
uniform float u_fFlatness;

#ifdef SUB_LEVEL
uniform sampler2D texSublevel;
uniform float u_fScaleSubLevel;
varying highp vec2 v_v2TexCoordSubLevel;
#endif


void main()
{
	float fScale = 1.0 / 16.0;
	float fPi = 3.1415926535897932384626433832795;
	float f2Pi = 2.0 * fPi;
	gl_FragColor.rgba = vec4(0.0, 0.0, 0.0, 0.0);
	vec2 v2Offset = vec2(0.0, 0.0);

	gl_FragColor.xyz = vec3(0.0, 0.0, 0.0);

	for (int i = 0; i < ARRAY_SIZE; i++)
	{
		float fLength = u_fScaleArray[i];
		float fContribution = u_fContributionArray[i];
		vec2 v2Normal = u_v2NormalArray[i];
		//vec4 v4Texture = texture2D(tex, v_arrv2TexCoord[i].st + v2Offset * fLength);
		vec2 arrv2TexCoord = v_arrv2TexCoord[i];
        vec4 v4Texture = texture2D(tex, vec2(arrv2TexCoord.s + dot(v2Offset, v2Normal) * fLength, arrv2TexCoord.t));
		v4Texture.rg = v4Texture.rg * 2.0 - vec2(1.0, 1.0);		
		vec2 v2Tmp = v2Normal * v4Texture.y * -fScale;
		//v2Tmp.x = - v2Tmp.x;

		gl_FragColor.xz += v2Tmp * fContribution;
		gl_FragColor.y += v4Texture.x / (1.0 + arrv2TexCoord.y * 12.0) * fContribution;
		//gl_FragColor.xz += v2Tmp;
		//gl_FragColor.y += v4Texture.x / (1.0 + u_fChoppyness * 12.0);
		
		

	/*	// rotate normal method B
		//vec3 v3Normal = vec3(v2Tmp.x, v4Texture.x / (1.0 + u_fChoppyness * 12.0) * 2.0 + 1.0, v2Tmp.y);
		vec3 v3Normal = vec3(-v2Tmp.x, v4Texture.x  * fScale + fContribution / (0.4 + u_fChoppyness * 2.0), -v2Tmp.y);
		v3Normal = normalize(v3Normal);		
		vec3 t = vec3(gl_FragColor.x, gl_FragColor.y + 1.0, gl_FragColor.z);
		vec3 u = vec3(-v3Normal.x, v3Normal.y, -v3Normal.z);
		//gl_FragColor.xyz = t*dot(t, u)/t.y - u;
		gl_FragColor.xyz = normalize(t*dot(t, u) - u*t.y);*/


		v2Offset += v4Texture.w / (fLength * fLength) * v2Normal * fContribution;
	}
	
#ifdef SUB_LEVEL
	{
		vec4 v4Texture = texture2D(texSublevel, v_v2TexCoordSubLevel.st + v2Offset * 1.0 * u_fScaleSubLevel);
		vec3 v3Normal;
		v3Normal.xz = v4Texture.rg * 2.0 - 1.0;
		v3Normal.y = sqrt(1.0 - dot(v3Normal.xz, v3Normal.xz));
		gl_FragColor.xyz += v3Normal.xyz * 0.5;
		v2Offset += (gl_FragColor.zw * 2.0 - 1.0) * 0.125 * 0.5;
	}
#endif
	
	gl_FragColor.xyz += (vec3(0.0, 1.0, 0.0) - gl_FragColor.xyz) * u_fFlatness;

	gl_FragColor.rg = (normalize(gl_FragColor.rgb) * 0.5 + vec3(0.5)).rb;	
	v2Offset *= 4.0;
	gl_FragColor.zw = (v2Offset + 1.0) * 0.5;

	
	//gl_FragColor.xy = gl_FragColor.zw;
	//gl_FragColor.zw = vec2(0.0);
	//gl_FragColor.x = 0.0;

	//gl_FragColor.rgb = vec3(gl_FragColor.y);

	//gl_FragColor.x = sin(v_v2TexCoord.y * f2Pi) * 0.5 + 0.5;
	//gl_FragColor.z = sin(v_v2TexCoord.y * f2Pi * 10.0) * 0.5 + 0.5;
	//gl_FragColor.y = sin(length(v_v2TexCoord.xy) * f2Pi * 10.0) * 0.5 + 0.5;

}
