


uniform mat4 u_m44ModelViewProjection;

attribute vec4 a_v4Position;

varying highp vec2 v_arrv2TexCoord[ARRAY_SIZE];

uniform vec2 u_v2NormalArray[ARRAY_SIZE];
uniform float u_fScaleArray[ARRAY_SIZE];
uniform float u_fOffsetArray[ARRAY_SIZE];
uniform float u_fChoppynessFudge[ARRAY_SIZE];
uniform float u_fChoppyness;

//uniform float u_fScale2;

#ifdef SUB_LEVEL
uniform mat2 u_m22SubLevel;
varying highp vec2 v_v2TexCoordSubLevel;
#endif



//varying vec2 v_v2TexCoord;


void main() 
{
	float fPi = 3.1415926535897932384626433832795;
	float f2Pi = 2.0 * fPi;
	gl_Position = u_m44ModelViewProjection * a_v4Position;

	for (int i = 0; i < ARRAY_SIZE; i++)
	{
		//float fI = float(i);
		vec2 v2NormalArray = u_v2NormalArray[i];
		float fScaleArray = u_fScaleArray[i];
		float fOffsetArray = u_fOffsetArray[i];
		float fChoppynessFudge = u_fChoppynessFudge[i];
		float fResult1 = (dot(gl_Position.xy * 0.5, v2NormalArray * fScaleArray) + fOffsetArray);// * u_fScale2;
		float fResult2 = u_fChoppyness - u_fChoppyness * 0.075 * float(ARRAY_SIZE - 1 - i) / float(ARRAY_SIZE);// * (0.5 + 0.5 * float(ARRAY_SIZE - i - 1) / float(ARRAY_SIZE));
		fResult2 *= fChoppynessFudge;
		v_arrv2TexCoord[i].x = fResult1;
		v_arrv2TexCoord[i].y = fResult2;
		//v_arrv2TexCoord[i].y = float(i) / float(ARRAY_SIZE);
	}

#ifdef SUB_LEVEL
	v_v2TexCoordSubLevel = u_m22SubLevel * gl_Position.xy; 
#endif

}
