
precision mediump float;

uniform sampler2D tex;
uniform sampler2D texMask;

varying mediump vec2 v_v2TexCoord;
varying mediump vec2 v_v2TexCoord2;
varying lowp vec4 v_v4Color;
varying mediump float v_fAlphaVFade;

void main() 
{
	float fAlpha = v_fAlphaVFade;
	vec4 v4Color = v_v4Color;
	if (fAlpha > 1.0)
		fAlpha = 1.0;
	v4Color.a *= fAlpha;
	vec4 v4Texture = texture2D(tex, v_v2TexCoord/*, 1.0*/);
	vec4 v4TextureMask = texture2D(texMask, v_v2TexCoord2/*, 1.0*/);
	gl_FragColor = v4TextureMask * v4Texture * v4Color;
}
