
precision mediump float;

uniform sampler2D tex;

varying mediump vec2 v_v2TexCoord;
varying lowp vec4 v_v4Color;
varying mediump float v_fAlphaVFadeLeft;
varying mediump float v_fAlphaVFadeRight;
varying mediump float v_fAlphaVFadeTop;
varying mediump float v_fAlphaVFadeBottom;

void main() 
{
	float fAlphaA = min(v_fAlphaVFadeTop, v_fAlphaVFadeBottom);
	float fAlphaB = min(v_fAlphaVFadeLeft, v_fAlphaVFadeRight);

	float fAlpha = min( fAlphaA, fAlphaB);
	fAlpha = smoothstep(0.0, 0.001,fAlpha);

	vec4 v4Color = v_v4Color;
	v4Color.a *= fAlpha;

	vec4 v4Texture = texture2D(tex, v_v2TexCoord);
	gl_FragColor = v4Texture * v4Color;	

}

