

uniform mat4 u_m44ModelViewProjection;
uniform float u_fZOffset;
uniform float u_fZClamp;
uniform float u_fMinZOffset; 

attribute vec4 a_v4Position;
attribute vec2 a_v2TexCoord;

varying vec2 v_v2TexCoord;

void main() 
{
	v_v2TexCoord = a_v2TexCoord;
	gl_Position = u_m44ModelViewProjection * a_v4Position;
	float fDiv = gl_Position.w;
	if (fDiv < u_fZClamp)
		fDiv = u_fZClamp;
	float zOffset = u_fZOffset / fDiv;
	if (zOffset < u_fMinZOffset)
		zOffset = u_fMinZOffset;
	gl_Position.z -= zOffset;
}

